OSDN Git Service

* gcc_release (build_sources): Do not use "-r" and "-D" at the
[pf3gnuchains/gcc-fork.git] / maintainer-scripts / gcc_release
1 #! /bin/sh
2
3 ########################################################################
4 #
5 # File:   gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date:   2001-05-25
8 #
9 # Contents:
10 #   Script to create a GCC release.
11 #
12 # Copyright (c) 2001, 2002 Free Software Foundation.
13 #
14 # This file is part of GCC.
15 #
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
20 #
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
24 # GNU General Public License for more details.
25 #
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING.  If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
30 #
31 ########################################################################
32
33 ########################################################################
34 # Notes
35 ########################################################################
36
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
39 #
40 #   gcc_release -r 3.0.2
41 #
42 # This script will automatically use the head of the release branch
43 # to generate the release.
44
45 ########################################################################
46 # Functions
47 ########################################################################
48
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
51
52 error() {
53     echo "gcc_release: error: $1"
54     exit 1
55 }
56
57 # Issue the informational message given by $1.
58
59 inform() {
60     echo "gcc_release: $1"
61 }
62
63 # Issue a usage message explaining how to use this script.
64
65 usage() {
66 cat <<EOF
67 gcc_release -r release [-f] [further options]
68 gcc_release -s name:cvsbranch [further options]
69
70 Options:
71
72   -r release           Version of the form X.Y or X.Y.Z.
73   -s name:cvsbranch    Create a snapshot, not a real release.
74
75   -d destination       Local working directory where we will build the release
76                        (default=${HOME}).
77   -f                   Create a final release (and update ChangeLogs,...).
78   -l                   Indicate that we are running on gcc.gnu.org.
79   -p previous-tarball  Location of a previous tarball (to generate diff files).
80   -t tag               Tag to mark the release in CVS.
81   -u username          Username for upload operations.
82 EOF
83     exit 1
84 }
85
86 # Change to the directory given by $1.
87
88 changedir() {
89   cd $1 || \
90     error "Could not change directory to $1"
91 }
92
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree.  Return another name for that directory, relative
95 # to the working directory.
96
97 adjust_dirs() {
98   for x in $@; do
99     echo `basename ${SOURCE_DIRECTORY}`/$x
100   done
101 }
102
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
105
106 build_sources() {
107   # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108   if [ -r ${WORKING_DIRECTORY} ]; then
109     error "\`${WORKING_DIRECTORY}' already exists"
110   fi
111   # Create the WORKING_DIRECTORY.
112   mkdir "${WORKING_DIRECTORY}" \
113     || error "Could not create \`${WORKING_DIRECTORY}'"
114   changedir "${WORKING_DIRECTORY}"
115
116   # If this is a final release, make sure that the ChangeLogs
117   # and version strings are updated.
118   if [ ${FINAL} -ne 0 ]; then
119     inform "Updating ChangeLogs and version files"
120
121     ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
122            -r ${CVSBRANCH} gcc || \
123            error "Could not check out release sources"
124     for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125       # Update this ChangeLog file only if it does not yet contain the
126       # entry we are going to add.  (This is a safety net for repeated
127       # runs of this script for the same release.)
128       if ! grep "GCC ${RELEASE} released." ${x} > /dev/null ; then       
129         cat - ${x} > ${x}.new <<EOF
130 ${LONG_DATE}  Release Manager
131
132         * GCC ${RELEASE} released.
133
134 EOF
135         mv ${x}.new ${x} || \
136             error "Could not update ${x}"
137         (changedir `dirname ${x}` && \
138             ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
139             error "Could not commit ${x}"
140       fi
141     done
142
143     # Update `gcc/version.c'.
144     for x in gcc/version.c; do 
145       y=`basename ${x}`
146       (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
147           sed -e 's|version_string\[\] = \".*\"|version_string\[\] = \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
148           mv ${y}.new ${y} && \
149           ${CVS} ci -m 'Update version' ${y}) || \
150           error "Could not update ${x}"
151     done
152
153     # Make sure we tag the sources for a final release.
154     TAG="gcc_`echo ${RELEASE} | tr . _`_release"
155
156     rm -rf ${SOURCE_DIRECTORY}
157   fi
158
159   # Tag the sources.
160   EXPORTDATE=""
161   if [ -n "${TAG}" ]; then
162     inform "Tagging sources as ${TAG}"
163     ${CVS} rtag -r ${CVSBRANCH} -F ${TAG} gcc || \
164       error "Could not tag sources"
165     EXPORTTAG="-r${TAG}"
166   else
167     if [ ${CVSBRANCH} != "HEAD" ]; then
168       EXPORTTAG="-r${CVSBRANCH}"
169       # It does not work to use both "-r" and "-D" with
170       # "cvs export" so EXPORTDATE is not set here.
171     else
172       # HEAD is the default branch, no need to specify it.
173       EXPORTTAG=""
174       EXPORTDATE="-D`date -u +"%Y-%m-%d %H:%M"` UTC"
175     fi
176   fi
177
178   # Export the current sources.
179   inform "Retrieving sources (cvs export ${EXPORTTAG} ${EXPORTDATE} gcc)"
180
181   if [ -z "${EXPORTTAG}" ]; then
182     ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
183        "${EXPORTDATE}" gcc || \
184       error "Could not retrieve sources"
185   elif [ -z "${EXPORTDATE}" ]; then
186     ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
187        "${EXPORTTAG}" gcc || \
188       error "Could not retrieve sources"
189   else
190     error "Cannot specify -r and -D at the same time"
191   fi
192
193   # Run gcc_update on them to set up the timestamps nicely, and (re)write
194   # the LAST_UPDATED file containing the CVS tag/date used.
195   changedir "gcc-${RELEASE}"
196   contrib/gcc_update --touch
197   echo "Obtained from CVS: ${EXPORTTAG} ${EXPORTDATE}" > LAST_UPDATED
198
199   # Obtain some documentation files from the wwwdocs module.
200   inform "Retrieving HTML documentation"
201   changedir "${WORKING_DIRECTORY}"
202   for x in bugs faq; do
203     (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
204      cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
205         ${SOURCE_DIRECTORY}) || \
206       error "Could not retrieve ${x}.html"
207   done
208
209   inform "Generating plain-text documentation from HTML"
210   changedir "${SOURCE_DIRECTORY}"
211   for file in *.html; do
212     newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
213     (${ENV} TERM=vt100 lynx -dump $file \
214        | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
215        > $newfile) || \
216      error "Could not generate text-only version of ${file}"
217   done
218
219   # For a prerelease or real release, we need to generate additional
220   # files not present in CVS.
221   changedir "${SOURCE_DIRECTORY}"
222   if [ $SNAPSHOT -ne 1 ]; then
223     # Generate the documentation.
224     inform "Building install docs"
225     SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
226     DESTDIR=${SOURCE_DIRECTORY}/INSTALL
227     export SOURCEDIR
228     export DESTDIR
229     ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
230
231     # Regenerate the NEWS file.
232     contrib/gennews > gcc/NEWS || \
233       error "Could not regenerate NEWS files"
234
235     # Now, we must build the compiler in order to create any generated
236     # files that are supposed to go in the source directory.  This is
237     # also a good sanity check to make sure that the release builds
238     # on at least one platform.
239     inform "Building compiler"
240     OBJECT_DIRECTORY=../objdir
241     contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} \
242       -c "--enable-generated-files-in-srcdir" build || \
243       error "Could not rebuild GCC"
244   fi
245
246   # Move message catalogs to source directory.
247   mv ../objdir/gcc/po/*.gmo gcc/po/
248
249   # Create a `.brik' file to use for checking the validity of the
250   # release.
251   changedir "${SOURCE_DIRECTORY}"
252   BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
253   ((find . -type f | sort > $BRIK_FILE) && \
254        brik -Gb -f ${BRIK_FILE} > .brik && \
255        rm ${BRIK_FILE}) || \
256      error "Could not compute brik checksum"
257 }
258
259 # Buid a single tarfile.  The first argument is the name of the name
260 # of the tarfile to build, without any suffixes.  They will be added
261 # automatically.  The rest of the arguments are the files or
262 # directories to include.
263
264 build_tarfile() {
265   # Get the name of the destination tar file.
266   TARFILE="$1.tar.bz2"
267   shift
268
269   # Build the tar file itself.
270   (${TAR} cf - "$@" | ${BZIP2} > ${TARFILE}) || \
271     error "Could not build tarfile"
272   FILE_LIST="${FILE_LIST} ${TARFILE}"
273 }
274
275 # Build the various tar files for the release.
276
277 build_tarfiles() {
278   inform "Building tarfiles"
279
280   changedir "${WORKING_DIRECTORY}"
281
282   # The GNU Coding Standards specify that all files should
283   # world readable.
284   chmod -R a+r ${SOURCE_DIRECTORY}
285   # And that all directories have mode 777.
286   find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
287  
288   # Build one huge tarfile for the entire distribution.
289   build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
290
291   # Now, build one for each of the languages.
292   build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
293   build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
294   build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
295   build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
296   build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
297   build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
298    
299   # The core is everything else.
300   EXCLUDES=""
301   for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
302            ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
303     EXCLUDES="${EXCLUDES} --exclude $x"
304   done
305   build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
306     `basename ${SOURCE_DIRECTORY}`
307 }
308
309 # Build .gz files.
310 build_gzip() {
311   for f in ${FILE_LIST}; do
312     target=${f%.bz2}.gz
313     (${BZIP2} -d -c $f | ${GZIP} > ${target}) || error "Could not create ${target}"
314   done
315 }
316
317 # Build diffs against an old release.
318 build_diffs() {
319   old_dir=${1%/*}
320   old_file=${1##*/}
321   old_vers=${old_file%.tar.bz2}
322   old_vers=${old_vers#gcc-}
323   inform "Building diffs against version $old_vers"
324   for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
325     old_tar=${old_dir}/${f}-${old_vers}.tar.bz2
326     new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.bz2
327     if [ ! -e $old_tar ]; then
328       inform "$old_tar not found; not generating diff file"
329     elif [ ! -e $new_tar ]; then
330       inform "$new_tar not found; not generating diff file"
331     else
332       build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
333         ${f}-${old_vers}-${RELEASE}.diff.bz2
334     fi
335   done
336 }
337
338 # Build an individual diff.
339 build_diff() {
340   changedir "${WORKING_DIRECTORY}"
341   tmpdir=gccdiff.$$
342   mkdir $tmpdir || error "Could not create directory $tmpdir"
343   changedir $tmpdir
344   (${BZIP2} -d -c $1 | ${TAR} xf - ) || error "Could not unpack $1 for diffs"
345   (${BZIP2} -d -c $3 | ${TAR} xf - ) || error "Could not unpack $3 for diffs"
346   ${DIFF} $2 $4 > ../${5%.bz2}
347   if [ $? -eq 2 ]; then
348     error "Trouble making diffs from $1 to $3"
349   fi
350   ${BZIP2} ../${5%.bz2} || error "Could not generate ../$5"
351   changedir ..
352   rm -rf $tmpdir
353   FILE_LIST="${FILE_LIST} $5"
354 }
355
356 # Upload the files to the FTP server.
357 upload_files() {
358   inform "Uploading files"
359
360   changedir "${WORKING_DIRECTORY}"
361
362   # Make sure the directory exists on the server.
363   if [ $LOCAL -eq 0 ]; then
364     ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
365       mkdir -p "${FTP_PATH}/diffs"
366     UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
367   else
368     mkdir -p "${FTP_PATH}/diffs" \
369       || error "Could not create \`${FTP_PATH}'"
370     UPLOAD_PATH=${FTP_PATH}
371   fi
372
373   # Then copy files to their respective (sub)directories.
374   for x in gcc*.gz gcc*.bz2; do
375     if [ -e ${x} ]; then
376       # Make sure the file will be readable on the server.
377       chmod a+r ${x}
378       # Copy it.
379       case ${x} in
380         *.diff.*)
381           SUBDIR="diffs/";
382           ;;
383         *)
384           SUBDIR="";
385       esac
386       ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
387         || error "Could not upload ${x}"
388     fi
389   done
390 }
391
392 # Announce a snapshot, both on the web and via mail.
393 announce_snapshot() {
394   inform "Updating links and READMEs on the FTP server"
395   
396   TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
397   changedir "${SNAPSHOTS_DIR}"
398   sed -e "s%@DATE@%$DATE%g" \
399     -e "s%@TEXT_DATE@%$TEXT_DATE%g" \
400     -e "s%@LAST_DATE@%$LAST_DATE%g" \
401     -e "s%@BRANCH@%${BRANCH}%g" \
402     -e "s%@RELEASE@%${RELEASE}%g" \
403     -e "s%@EXPORT@%${EXPORTTAG} ${EXPORTDATE}%g" \
404     ~/scripts/snapshot-README > $$
405   mv $$ ${RELEASE}/README
406   sed -e "s%@DATE@%$DATE%g" \
407     -e "s%@TEXT_DATE@%$TEXT_DATE%g" \
408     -e "s%@LAST_DATE@%$LAST_DATE%g" \
409     -e "s%@BRANCH@%${BRANCH}%g" \
410     -e "s%@RELEASE@%${RELEASE}%g" \
411     -e "s%@EXPORT@%${EXPORTTAG} ${EXPORTDATE}%g" \
412     ~/scripts/snapshot-index.html > $$
413   mv $$ ${RELEASE}/index.html
414
415   touch LATEST-IS-${BRANCH}-${DATE}
416   rm -f LATEST-IS-${BRANCH}-${LAST_DATE}
417
418   inform "Sending mail"
419
420   export QMAILHOST=gcc.gnu.org
421   mail -s "gcc-ss-${RELEASE} is now available" gcc@gcc.gnu.org < ${SNAPSHOTS_DIR}/${RELEASE}/README
422 }
423
424 ########################################################################
425 # Initialization
426 ########################################################################
427
428 # Today's date.
429 DATE=`date "+%Y%m%d"`
430 LONG_DATE=`date "+%Y-%m-%d"`
431
432 # The CVS server containing the GCC repository.
433 CVS_SERVER="gcc.gnu.org"
434 # The path to the repository on that server.
435 CVS_REPOSITORY="/cvs/gcc"
436 # The CVS protocol to use.
437 CVS_PROTOCOL="ext"
438 # The username to use when connecting to the server.
439 CVS_USERNAME="${USER}"
440
441 # The machine to which files will be uploaded.
442 GCC_HOSTNAME="gcc.gnu.org"
443 # The name of the account on the machine to which files are uploaded.
444 GCC_USERNAME="gccadmin"
445 # The directory in which the files will be placed (do not use ~user syntax).
446 FTP_PATH=/var/ftp/pub/gcc
447 # The directory in which snapshots will be placed.
448 SNAPSHOTS_DIR=${FTP_PATH}/snapshots
449
450 # The major number for the release.  For release `3.0.2' this would be 
451 # `3'
452 RELEASE_MAJOR=""
453 # The minor number for the release.  For release `3.0.2' this would be
454 # `0'.
455 RELEASE_MINOR=""
456 # The revision number for the release.  For release `3.0.2' this would
457 # be `2'.
458 RELEASE_REVISION=""
459 # The complete name of the release.
460 RELEASE=""
461
462 # The name of the branch from which the release should be made, in a 
463 # user-friendly form.
464 BRANCH=""
465
466 # The name of the branch from which the release should be made, as used
467 # for our version control system.
468 CVSBRANCH=""
469
470 # The tag to apply to the sources used for the release.
471 TAG=""
472
473 # The old tarballs from which to generate diffs.
474 OLD_TARS=""
475
476 # The directory that will be used to construct the release.  The
477 # release itself will be placed in a subdirectory of this diretory.
478 DESTINATION=${HOME}
479 # The subdirectory.
480 WORKING_DIRECTORY=""
481 # The directory that will contain the GCC sources.
482 SOURCE_DIRECTORY=""
483
484 # The directories that should be part of the various language-specific
485 # tar files.  These are all relative to the top of the source tree.
486 ADA_DIRS="gcc/ada libada"
487 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
488 FORTRAN_DIRS="gcc/f libf2c"
489 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
490 OBJECTIVEC_DIRS="gcc/objc libobjc"
491 TESTSUITE_DIRS="gcc/testsuite"
492
493 # Non-zero if this is the final release, rather than a prerelease.
494 FINAL=0
495
496 # Non-zero if we are building a snapshot, and don't build gcc or
497 # include generated files.
498 SNAPSHOT=0
499
500 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
501 # and copy directly to the FTP directory.
502 LOCAL=0
503
504 # Major operation modes.
505 MODE_GZIP=0
506 MODE_DIFFS=0
507 MODE_SOURCES=0
508 MODE_TARFILES=0
509 MODE_UPLOAD=0
510
511 # List of archive files generated; used to create .gz files from .bz2.
512 FILE_LIST=""
513
514 # Programs we use.
515
516 BZIP2="${BZIP2:-bzip2}"
517 CVS="${CVS:-cvs -f -Q -z9}"
518 DIFF="${DIFF:-diff -Nrc3pad}"
519 ENV="${ENV:-env}"
520 GZIP="${GZIP:-gzip --best}"
521 SCP="${SCP:-scp -p}"
522 SSH="${SSH:-ssh}"
523 TAR="${TAR:-tar}"
524
525 ########################################################################
526 # Command Line Processing
527 ########################################################################
528
529 # Parse the options.
530 while getopts "d:fr:u:t:p:s:l" ARG; do
531     case $ARG in
532     d)    DESTINATION="${OPTARG}";;
533     r)    RELEASE="${OPTARG}";;
534     t)    TAG="${OPTARG}";;
535     u)    CVS_USERNAME="${OPTARG}";;
536     f)    FINAL=1;;
537     s)    SNAPSHOT=1
538           BRANCH=${OPTARG%:*}
539           CVSBRANCH=${OPTARG#*:}
540           ;;
541     l)    LOCAL=1
542           SCP=cp
543           PATH=~:/usr/local/bin:$PATH;;
544     p)    OLD_TARS="${OLD_TARS} ${OPTARG}"
545           if [ ! -f ${OPTARG} ]; then
546             error "-p argument must name a tarball"
547           fi;;
548     \?)   usage;;
549     esac
550 done
551 shift `expr ${OPTIND} - 1`
552
553 # Handle the major modes.
554 while [ $# -ne 0 ]; do
555     case $1 in
556     diffs)    MODE_DIFFS=1;;
557     gzip)     MODE_GZIP=1;;
558     sources)  MODE_SOURCES=1;;
559     tarfiles) MODE_TARFILES=1;;
560     upload)   MODE_UPLOAD=1;;
561     all)      MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_UPLOAD=1;
562               if [ $SNAPSHOT -ne 1 ]; then
563                 # Only for releases and pre-releases.
564                 MODE_GZIP=1;
565               fi
566               ;;
567     *)        error "Unknown mode $1";;
568     esac
569     shift
570 done
571
572 # Perform consistency checking.
573 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
574   error "No username specified"
575 fi
576
577 if [ ! -d ${DESTINATION} ]; then
578   error "\`${DESTINATION}' is not a directory"
579 fi
580
581 if [ $SNAPSHOT -eq 0 ]; then
582   if [ -z ${RELEASE} ]; then
583     error "No release number specified"
584   fi
585
586   # Compute the major and minor release numbers.
587   RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
588   RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
589   RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
590
591   if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
592     error "Release number \`${RELEASE}' is invalid"
593   fi
594
595   # Compute the full name of the release.
596   if [ -z "${RELEASE_REVISION}" ]; then
597     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
598   else
599     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
600   fi
601
602   # Compute the name of the branch, which is based solely on the major
603   # and minor release numbers.
604   CVSBRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
605
606   # If this is not a final release, set various parameters acordingly.
607   if [ ${FINAL} -ne 1 ]; then
608     RELEASE="${RELEASE}-${DATE}"
609     FTP_PATH="${FTP_PATH}/prerelease-${RELEASE}/"
610   else
611     FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
612   fi
613 else
614   RELEASE=${BRANCH}-${DATE}
615   FTP_PATH="${FTP_PATH}/snapshots/${RELEASE}"
616   if [ ${CVSBRANCH} != "HEAD" ]; then
617     TAG=gcc-ss-`echo ${RELEASE} | tr '.' '_'`
618   fi
619
620   # If diffs are requested when building locally on gcc.gnu.org, we (usually)
621   # know what the last snapshot date was and take the corresponding tarballs,
622   # unless the user specified tarballs explictly.
623   if [ $MODE_DIFFS -ne 0 ] && [ $LOCAL -ne 0 ] && [ -z "${OLD_TARS}" ]; then
624     LAST_DATE=`cat ~/.snapshot_date-${BRANCH}`
625     OLD_TARS=${SNAPSHOTS_DIR}/${BRANCH}-${LAST_DATE}/gcc-${BRANCH}-${LAST_DATE}.tar.bz2
626   fi
627 fi
628
629 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
630 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
631 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
632
633 # Recompute the names of all the language-specific directories,
634 # relative to the WORKING_DIRECTORY.
635 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
636 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
637 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
638 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
639 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
640 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
641
642 # Set up CVSROOT.
643 if [ $LOCAL -eq 0 ]; then
644     CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
645     CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
646 else
647     CVSROOT="${CVS_REPOSITORY}"
648 fi
649 export CVSROOT
650
651 ########################################################################
652 # Main Program
653 ########################################################################
654
655 # Set the timezone to UTC
656 TZ="UTC0"
657 export TZ
658
659 # Build the source directory.
660
661 if [ $MODE_SOURCES -ne 0 ]; then
662   build_sources
663 fi
664
665 # Build the tar files.
666
667 if [ $MODE_TARFILES -ne 0 ]; then
668   build_tarfiles
669 fi
670
671 # Build diffs
672
673 if [ $MODE_DIFFS -ne 0 ]; then
674   # Possibly build diffs.
675   if [ -n "$OLD_TARS" ]; then
676     for old_tar in $OLD_TARS; do
677       build_diffs $old_tar
678     done
679   fi
680 fi
681
682 # Build gzip files
683 if [ $MODE_GZIP -ne 0 ]; then
684   build_gzip
685 fi
686
687 # Upload them to the FTP server.
688
689 if [ $MODE_UPLOAD -ne 0 ]; then
690   upload_files
691
692   # For snapshots, make some further updates.
693   if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
694     announce_snapshot
695
696     # Update snapshot date file.
697     changedir ~
698     echo $DATE > .snapshot_date-${BRANCH}
699
700     # Remove working directory
701     rm -rf ${WORKING_DIRECTORY}
702   fi
703 fi